/****************************************************************************/
/** UBrowseDlg.cpp                                                         **/
/** ---------------------------------------------------------------------- **/
/** ---------------------------------------------------------------------- **/
/** June 14, 1998 by Oleg Kagan                                            **/
/****************************************************************************/

//============================================================================
#include "stdafx.h"
#pragma hdrstop

//============================================================================
#include "ubrowse.h"
#include "UBrowseDlg.h"

//============================================================================
#include "browser.h"

//============================================================================
//#ifdef _DEBUG
//#define new DEBUG_NEW
//#undef THIS_FILE
//static char THIS_FILE[] = __FILE__;
//#endif

// CUBrowseDlg implementation
//============================================================================
CUBrowseDlg::CUBrowseDlg(

	CWnd* pParent /*=NULL*/
): 
	CDialog(CUBrowseDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUBrowseDlg)
	//}}AFX_DATA_INIT

	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	//-----------------------------------------------------------------------
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
} /*CUBrowseDlg::CUBrowseDlg(CWnd* =NULL)*/

//----------------------------------------------------------------------------
void CUBrowseDlg::DoDataExchange(

	CDataExchange* pDX
	
){
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CUBrowseDlg)
	DDX_Control(pDX, IDC_RESULT_EDIT, m_ResultEdit);
	DDX_Control(pDX, IDC_SINGLE_SELECTION_CHECK, m_SingleSelectionCheck);
	DDX_Control(pDX, IDC_NO_LOCAL_DOMAIN_CHECK, m_NoLocalDomainCheck);
	DDX_Control(pDX, IDC_INCLUDE_USERS_CHECK, m_IncludeUsersCheck);
	DDX_Control(pDX, IDC_INCLUDE_USER_BUTTONS_CHECK, m_IncludeUserButtonsCheck);
	DDX_Control(pDX, IDC_INCLUDE_SYSTEM_CHECK, m_IncludeSystemCheck);
	DDX_Control(pDX, IDC_INCLUDE_NETWORK_CHECK, m_IncludeNetworkCheck);
	DDX_Control(pDX, IDC_INCLUDE_INTERACTIVE_CHECK, m_IncludeInteractiveCheck);
	DDX_Control(pDX, IDC_INCLUDE_GROUPS_CHECK, m_IncludeGroupsCheck);
	DDX_Control(pDX, IDC_INCLUDE_EVERYONE_CHECK, m_IncludeEveryoneCheck);
	DDX_Control(pDX, IDC_INCLUDE_ALIASES_CHECK, m_IncludeAliasesCheck);
	DDX_Control(pDX, IDC_INCLUDE_CREATOR_OWNER_CHECK, m_IncludeCreatorOwnerCheck);
	//}}AFX_DATA_MAP
} /*CUBrowseDlg::DoDataExchange(CDataExchange*)*/

//----------------------------------------------------------------------------
BOOL CUBrowseDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog. The framework does this automatically
	// when the application's main window is not a dialog
	//---------------------------------------------------------------------
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//-------------------------------------

	// return TRUE unless you set the focus to a control
	//---------------------------------------------------
	return TRUE;  
} /*CUBrowseDlg::OnInitDialog()*/

//----------------------------------------------------------------------------
void CUBrowseDlg::OnPaint() 
{
	// If you add a minimize button to your dialog, you will need the code 
	// below to draw the icon.  For MFC applications using the document/view 
	// model, this is automatically done for you by the framework.

	if (IsIconic()) {
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		//---------------------------------
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		//---------------
		dc.DrawIcon(x, y, m_hIcon);
	} 
	else {
		CDialog::OnPaint();
	} /*iff*/
} /*CUBrowseDlg::OnPaint()*/

// The system calls this to obtain the cursor to display while the user drags
// the minimized window.
//----------------------------------------------------------------------------
HCURSOR CUBrowseDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
} /*CUBrowseDlg::OnQueryDragIcon()*/

//----------------------------------------------------------------------------
void CUBrowseDlg::OnTestButton() 
{
	DWORD uFlags = 0; {
		if (m_SingleSelectionCheck.GetCheck()) 
			uFlags |= OPENUSERBROWSER_SINGLE_SELECTION;
		if (m_NoLocalDomainCheck.GetCheck()) 
			uFlags |= OPENUSERBROWSER_NO_LOCAL_DOMAIN;
		if (m_IncludeSystemCheck.GetCheck()) 
			uFlags |= OPENUSERBROWSER_INCLUDE_SYSTEM;
		if (m_IncludeCreatorOwnerCheck.GetCheck()) 
			uFlags |= OPENUSERBROWSER_INCLUDE_CREATOR_OWNER;
		if (m_IncludeEveryoneCheck.GetCheck()) 
			uFlags |= OPENUSERBROWSER_INCLUDE_EVERYONE;
		if (m_IncludeInteractiveCheck.GetCheck()) 
			uFlags |= OPENUSERBROWSER_INCLUDE_INTERACTIVE;
		if (m_IncludeNetworkCheck.GetCheck()) 
			uFlags |= OPENUSERBROWSER_INCLUDE_NETWORK;
		if (m_IncludeUsersCheck.GetCheck()) 
			uFlags |= OPENUSERBROWSER_INCLUDE_USERS;
		if (m_IncludeUserButtonsCheck.GetCheck()) 
			uFlags |= OPENUSERBROWSER_INCLUDE_USER_BUTTONS;
		if (m_IncludeGroupsCheck.GetCheck()) 
			uFlags |= OPENUSERBROWSER_INCLUDE_GROUPS;
		if (m_IncludeAliasesCheck.GetCheck()) 
			uFlags |= OPENUSERBROWSER_INCLUDE_ALIASES;
	} /*uFlags*/

	TUserBrowser Browser;
	wchar_t wszTitle[1024];
	swprintf(wszTitle, L"Make Your Choice...(0x%lx)", (unsigned long)uFlags);

	bool bCancelled;
	DWORD dwError = ERROR_SUCCESS;
	std::wstring wsUsers = Browser.BrowseUsersStr(
		m_hWnd, wszTitle, L"", uFlags, &bCancelled, 10 * 1024, &dwError
	) /*Browser.BrowseUsersStr*/;

	if (dwError != ERROR_SUCCESS) {
		std::wstring wszError = Win32GetErrorExplanationW(dwError);
		::MessageBoxW(m_hWnd, wszError.c_str(), L"Error!!!", MB_OK);
	} /*if*/

	if (!bCancelled) SetWindowTextW(m_ResultEdit.m_hWnd, wsUsers.c_str());
} /*CUBrowseDlg::OnTestButton()*/

//----------------------------------------------------------------------------
BEGIN_MESSAGE_MAP(CUBrowseDlg, CDialog)
	//{{AFX_MSG_MAP(CUBrowseDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_TEST_BUTTON, OnTestButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP() /*CUBrowseDlg*/
