/****************************************************************************/
/** browser.h                                                              **/
/** ---------------------------------------------------------------------- **/
/** NT UserBrowser sample (NETUI.. family)                                 **/
/** ---------------------------------------------------------------------- **/
/** June 14, 1998 by Oleg Kagan (oleg_kagan@geocities.com)                 **/
/**                                                                        **/
/** April 22, 1999 by Oleg Kagan (oleg_kagan@geocities.com)                **/
/**   DWORD OPENUSERBROWSER::Unknown2 have been changed to BOOL fCancelled **/
/**   due to information received from Sergei Fefelov (asf@chat.ru)        **/
/**                                                   Thank You, Sergei... **/
/**                                                                        **/
/** October 09, 1999 by Oleg Kagan (oleg_kagan@geocities.com)              **/
/**   Error handling added due to request from Alex (adou@lycosmail.com)   **/
/**   (see p_dwLastError parameter at BrowseUsersStr)                      **/
/**                                                     Good luck, Alex... **/
/****************************************************************************/

//============================================================================
#include <windows.h>
#include <string>

// OPENUSERBROWSER
//============================================================================
typedef struct {
	DWORD cbSize;
	BOOL fCancelled;
	DWORD Unknown2;
    HWND hWndParent;
	LPCWSTR szTitle;
	LPCWSTR szDomainName;
    DWORD dwFlags;
	DWORD dwHelpId;
	LPCWSTR szHelpFile;
} OPENUSERBROWSER, * LPOPENUSERBROWSER;
typedef const OPENUSERBROWSER *LPCOPENUSERBROWSER;  

// ENUMUSERBROWSER
//============================================================================
typedef struct {
    SID_NAME_USE SidType;
	PSID Sid1;
	PSID Sid2;
	LPWSTR szFullName;
    LPWSTR szUserName;
	LPWSTR szDisplayName;
	LPWSTR szDomainName;
    LPWSTR szDescription;
} ENUMUSERBROWSER, * LPENUMUSERBROWSER;

//============================================================================
#define OPENUSERBROWSER_INCLUDE_SYSTEM        0x00010000
#define OPENUSERBROWSER_SINGLE_SELECTION      0x00001000
#define OPENUSERBROWSER_NO_LOCAL_DOMAIN       0x00000100
#define OPENUSERBROWSER_INCLUDE_CREATOR_OWNER 0x00000080
#define OPENUSERBROWSER_INCLUDE_EVERYONE      0x00000040
#define OPENUSERBROWSER_INCLUDE_INTERACTIVE   0x00000020
#define OPENUSERBROWSER_INCLUDE_NETWORK       0x00000010
#define OPENUSERBROWSER_INCLUDE_USERS         0x00000008
#define OPENUSERBROWSER_INCLUDE_USER_BUTTONS  0x00000004
#define OPENUSERBROWSER_INCLUDE_GROUPS        0x00000002
#define OPENUSERBROWSER_INCLUDE_ALIASES       0x00000001

//============================================================================
typedef HANDLE (WINAPI *TOpenUserBrowserPtr)(LPCOPENUSERBROWSER);
//----------------------------------------------------------------------------
typedef BOOL (WINAPI *TEnumUserBrowserSelectionPtr)(
	HANDLE, LPENUMUSERBROWSER, LPDWORD
) /*TEnumUserBrowserSelectionPtr*/;
//----------------------------------------------------------------------------
typedef BOOL (WINAPI *TCloseUserBrowserPtr)(HANDLE);

//============================================================================
class TUserBrowser {
public:
	//------------------------------------------------------------------------
	TUserBrowser();

	//------------------------------------------------------------------------
	std::wstring BrowseUsersStr(
		HWND hParent, const std::wstring c_sTitle, 
		const std::wstring& c_sDomain, DWORD uFlags,
		bool* p_bCancelled,
		size_t nBufferSize = 2048,
		DWORD* p_dwLastError = NULL
	) /*BrowseUsersStr(HWND, const std::wstring, const std::wstring&, ...)*/;

protected:
	//------------------------------------------------------------------------
	HANDLE hBrowser;
	HINSTANCE hNetUiDll;
	TOpenUserBrowserPtr pOpenUserBrowser;
	TEnumUserBrowserSelectionPtr pEnumUserBrowserSelection;
	TCloseUserBrowserPtr pCloseUserBrowser;
} /*TUserBrowser*/;
