/****************************************************************************/
/** ubrowse.cpp                                                            **/
/** ---------------------------------------------------------------------- **/
/** Defines the class behaviors for the application                        **/
/** ---------------------------------------------------------------------- **/
/** June 14, 1998 by Oleg Kagan                                            **/
/****************************************************************************/

//============================================================================
#include "stdafx.h"
#pragma hdrstop

//============================================================================
#include "ubrowse.h"
#include "UBrowseDlg.h"

//============================================================================
//#ifdef _DEBUG
//#define new DEBUG_NEW
//#undef THIS_FILE
//static char THIS_FILE[] = __FILE__;
//#endif /*_DEBUG*/

//============================================================================
BOOL Win32IsNT()
{
	static unsigned uIsNT = 2;
	if (uIsNT > 1) {
		// Check NT or Win95/98
		//----------------------
		OSVERSIONINFO VersionInfo; {
			VersionInfo.dwOSVersionInfoSize = sizeof(VersionInfo);
			GetVersionEx(&VersionInfo);
		} /*VersionInfo*/

		uIsNT = (VersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT);
	} /*if*/
	return (uIsNT != 0);
} /*Win32IsNT()*/

//============================================================================
std::wstring Win32GetErrorExplanationW(

	DWORD uError /*= null*/

){
	if (!uError) uError = GetLastError();

	std::wstring wsExplanation;

	wchar_t* wszExplanation;
	FormatMessageW(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM |
			FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		uError,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(wchar_t*)(&wszExplanation), 0,
		NULL
	) /*FormatMessageW*/;
	if (wszExplanation) {
		wsExplanation = wszExplanation;
		LocalFree(wszExplanation); wszExplanation = NULL;

		// Delete tail characters
		//------------------------
		{
			int iLast = wsExplanation.length() - 1;
			while (
				(iLast >= 0) && 
				(
					(wsExplanation[iLast] == '\n') || 
					(wsExplanation[iLast] == '\r')
				)
			) --iLast;
			wsExplanation.resize((iLast >= 0) ? iLast + 1 : 0);
		} /*Delete tail characters*/
	} /*if*/

	return wsExplanation;
} /*Win32GetErrorExplanationW(DWORD)*/

// CUBrowseApp implementation
//============================================================================
CUBrowseApp::CUBrowseApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
} /*CUBrowseApp()*/

//----------------------------------------------------------------------------
BOOL CUBrowseApp::InitInstance()
{
	if (!Win32IsNT()) {
		MessageBox(
			NULL, 
			"Sorry, but this example works under Microsoft Windows NT only", 
			"User Browser Example", MB_OK | MB_ICONHAND | MB_SYSTEMMODAL
		) /*MessageBox*/;
		return EXIT_FAILURE;
	} /*if*/

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.
	//-----------------------------------------------------------------
	CUBrowseDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK) {
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	} 
	else if (nResponse == IDCANCEL) {
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	} /*iff*/

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	//--------------------------------------------------------------------
	return FALSE;
} /*CUBrowseApp::InitInstance()*/

//----------------------------------------------------------------------------
BEGIN_MESSAGE_MAP(CUBrowseApp, CWinApp)
	//{{AFX_MSG_MAP(CUBrowseApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP() /*CUBrowseApp*/

// The one and only CUBrowseApp object
//============================================================================
CUBrowseApp theApp;

